#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#define MAX 100
/* koostada sõnade sagedustabel antud tekstile*/
typedef struct{
	char word[MAX]; //sõna
	int cnt; //mitu korda
} sagedus_t;

typedef struct{
	int max; //hetkeline max suurus
	int n; //tegelik kirjete arv
	sagedus_t *M; //viit dünaamilisele massiivile
} dyn_t;

int vordle(const void *, const void *);
void top100(dyn_t );
char *korrasta(char *);
int lisa(dyn_t *, char *);

int main(/*int argc, char **argv*/){
	FILE *f = NULL;
	/*if(argc > 1){
		f = fopen(argv[1], "r"); //äkki anti failinimi parameetriga ette
	}*/
	char buf[1000];
	if(f == NULL){
		printf("Sisesta faili nimi: ");
		scanf("%999s", buf);
		f = fopen(buf, "r");
	}
	if(f == NULL){
		printf("Faili ei saanud avada.\n");
		return 0;
	}
	dyn_t andmed = {0, 0, NULL}; //
	int x; // abimuutuja, et kas lisamine õnnestus
	int wordcount = 0;
	struct timeval start, stop;
	gettimeofday(&start, NULL);
	while(!feof(f)){
		if(fscanf(f, "%99s", buf) == 1)
			x = lisa(&andmed, buf);
		else
			break; //  faililõpus
		if(x == 0){ //lisamine ebaõnnestus
			printf("Mälu ei antud.\n");
			break;
		} else
			wordcount++; //mitu sõna on loetud ja lisatud
	}
	
	printf("Sõnu kokku: %d\n", wordcount);
	printf("Unikaalseid sõnu: %d\n", andmed.n);
	top100(andmed);	
	gettimeofday(&stop, NULL);
	double aeg = stop.tv_sec +(stop.tv_usec / 1000000.0) -
		( start.tv_sec + start.tv_usec / 1000000.0);
	fclose(f);
	printf("Aega kulus %8.3f sekundit\n", aeg);
	free(andmed.M); // vabastame andmed
	return 0;
}
//võrdlusfunktsioon qsort jaoks
int vordle(const void *aa, const void *bb){
	sagedus_t *a = (sagedus_t*)aa, *b = (sagedus_t*)bb;
	return b->cnt - a->cnt;
}
//trükib välja 100 kõige sagedasemat sõna.
void top100(dyn_t r){
	qsort(r.M, r.n, sizeof(sagedus_t), vordle); //sorteerime kahanevas järjekorras
	int i;
	for(i = 0; i < r.n && i < 100; i++)
		printf("%s (%d)\n", r.M[i].word, r.M[i].cnt);
}
//kuna lähtematerjaliks on raamat, siis seal on palju jutumärke, kirjavahemärke jne.
//need segavad ja ilus oleks neist vabaneda
char *korrasta(char *s){
	int x;
	int offset = 0;
	if(strstr(s, "“") != NULL)
		offset = 3; //viskame algusest ära UTF-8 jutumärgi
	for(x = offset; x < strlen(s); x++)
		if(s[x] == '.' || s[x] == ',' || s[x] == ';' || s[x] == '!')
			s[x] = '\0'; //viskame lõpust minema stringi lõpu sümboli
	return &s[offset];
}
//lisab massiivi uue sõna või suurendab juba olemasoleva sõna sagedust
int lisa(dyn_t *p, char *ss){
	int i;
	char *s = korrasta(ss);
	for(i = 0; i < p->n; i++)
		if(strcmp(s, p->M[i].word) == 0) //kas uus sõna võrdne selle word'ga
		{
			p->M[i].cnt++; //suurendame arvu
			return 1; //suurendamine õnnestus
		}
	//kui me siia kohta satume, siis tegu uue sõnaga
	int x; //ajutine muutuja dün. suuruse jaoks
	void *pointer; //ajutine viit realloci jaoks
	if(p->n >= p->max - 1){ //kas dünaamiline massiiv on täis saanud?
		x = p->max;
		if(x < 10)
			x = 10;
		else
			x = x * 2; // suurendame massiivi 2 korda
		pointer = realloc(p->M, x * sizeof(sagedus_t));
		if(pointer == NULL){ //mälu ei antud (juurde)
			return 0; //lisamine ebaõnnestus
		}
		p->M = pointer; // dün massiivi uus asukoht
		p->max = x;
	}
	p->M[p->n].cnt = 1; //uus sõna on 1 kord olnud
	strcpy(p->M[p->n].word, s);
	p->n++;
	return 1; //lisamine õnnestus
}


/*Tirige gutenberg.org lehelt raamatuid ja katsetage neid. ;)
*/
